1 rem     -       User-configurable data
2 :
3 dir$ = 'ram1_pop_'
4 timep% = 100: rem Timeout before pop-up
5 timed% = 300: rem Pop-up display time
6 :
7 rem     -       Init constants
8 :
9 sp_hintbg%      = 553: rem Hint background
10 sp_hintfg%      = 554: rem Hint foreground
11 :
12 rem     -       Init program data
13 :
14 ev% = 0:     rem Events
15 it% = 1000:  rem Current item
16 lit% = it%:  rem Previous item
17 dim pv%(15): rem Init pointer record
18 :
19 rem     -       Init some display data
20 :
21 dim dat$(6, 12)
22 for i% = 0 to dimn(dat$): dat$(i%) = 'Data ' & i%
23 :
24 rem     -       Draw menu
25 :
26 ch% = fopen(#0; 'con_')
27 mdraw#ch%; dir$ & 'example_men'
28 mawdraw#ch%; 1, dat$
29 :
30 ww_wstat = mwdef(#ch%): ws_citem = peek_l(ww_wstat) + 48: rem Pointer to current item
31 :
32 rem     -       Main program loop
33 :
34 rep main
35  item = mcallt(#ch%, ev%, timep%)
36  pval#ch%; pv%
37  if item = -1280 then
38   rem timed out
39   lit% = it%
40   if pv%(2) >= 0 then
41    it% = 10 * (pv%(2) + 1)
42   else
43    it% = peek_w(ws_citem) * pv%(2)
44   endif
45   if it% = lit%: next main
46 :
47   sel on it%
48   =  0: Pop pv%(14), pv%(15), 'Move\this\Window'
49   = -1: Pop pv%(14), pv%(15), 'Quit\Program\\Now!\'
50   = 10 to 100: Pop pv%(14), pv%(15), 'Application\Window\#' & (pv%(2) + 1)
51   = remainder: Pop pv%(14), pv%(15), 'An\Example'
52   endsel
53   next main
54  else
55   if item < 0 then
56    select on item
57    = -1: rem Wmove (but never gets here)
58    = -2: quit
59    endsel
60   endif
61  endif
62 endrep main
63 :
64 rem     -       Pop and helper Routines
65 :
66 def proc Pop(x%, y%, txt$)
67 loc lp, cp%, xp%
68 loc w%, h%, s%, e%
69 rem V0.02 March 31st 2005
70 :
71 h% = 0: w% = 0: s% = 1
72 rem Count lines and find max width
73 rep lp
74  if s% > len(txt$): exit lp
75  e% = ('\' instr txt$(s% to len(txt$)))
76  if e% = 0: e% = len(txt$) - s% + 2
77  if e% > w%: w% = e%
78  s% = s% + e%
79  h% = h% + 1
80 endrep lp
81 :
82 rem Work out Hint window position and size
83 w% = w% * 6 + 4
84 xp% = x% - (w% div 2): if xp% < 2: xp% = 2
85 :
86 cp% = fopen('con_')
87 mdraw#cp%; dir$ & 'hint_men', xp%, y% + 2, w%, h% * 10 + 2
88 wm_ink#cp%; sp_hintfg%: wm_paper#cp%; sp_hintbg%
89 :
90 Split#cp%; w%, txt$
91 :
92 rdpt#cp%, 11, x%, y% + 2, timed%
93 mclear#cp%: close#cp%
94 enddef Pop
95 :
96 def proc Split(ch%, w%, txt$)
97 loc lp, s%, e%, h%, l%
98 rem Slice lines at \ and print centred
99 rem v0.03 December 28th 2005 - pixel justification
100 :
101 h% = 0: s% = 1: l% = len(txt$)
102 rem Extract and display lines
103 rep lp
104  if s% > l%: exit lp
105  e% = ('\' instr txt$(s% to l%))
106  if e% = 0: e% = l% - s% + 2
107  cursor#ch%; (w% - 6 * (e% - 1)) div 2, h% * 10 + 1
108  print#ch%; txt$(s% to s% + e% - 2);
109  s% = s% + e%
110  h% = h% + 1
111 endrep lp
112 enddef Split
113 :
